from vcCommand import *
import os.path, vcMatrix, vcVector


app = getApplication()
cmd = getCommand()


def OnStart():
  comp = app.TeachContext.ActiveRobot
  rou = app.TeachContext.ActiveRoutine
  scope = app.TeachContext.ActiveScope
  if not comp or not scope:
    print 'No robot selected.'
    return
  
  exe = rou.Program.Executor
  ctr = exe.Controller
  
  # Create handler
  handler = get_handler(comp)
  
  # Create statement
  icon_path = getCommandPath()[8:]
  base, filename = os.path.split(icon_path)
  icon_path = os.path.join(base, 'CT_Reset.svg')
  index = -1
  if app.TeachContext.ActiveStatementIndex >= 0:
    index = app.TeachContext.ActiveStatementIndex + 1
  stmt = scope.addStatement('Process', index, icon_path)
  stmt.Name = 'CT_Reset'
  stmt.Process = handler
  
  
  # Get base
  mt = ctr.createTarget()
  base = None
  for b in ctr.Bases:
    if b.Name == mt.BaseName:
      base = b
      break
  stmt.Base = base
  
  # Set new statement selected
  app.SelectionManager.setSelection(stmt)


def get_handler(comp):
  #Create and return statement handler
  
  handler = comp.getBehaviour('CTHandler')
  if not handler:
    handler = comp.createBehaviour(VC_PYTHONPROCESSHANDLER,'CTHandler')
  
  folder = os.path.dirname(cmd.getCommandPath())[8:] + '\\'
  file = open (folder + 'CTHandler.py', 'r')
  script = file.read()
  file.close() 
  if script != handler.Script:
    handler.Script = script
    print 'CTHandler updated.'
  
  return handler